git-subtree: add the generated script to the ignore file
[git/dscho.git] / git-am.sh
blobea49ca1793bab04d8bc55d5827a4cd6cc620c17c
1 #!/bin/sh
3 # Copyright (c) 2005, 2006 Junio C Hamano
5 SUBDIRECTORY_OK=Yes
6 OPTIONS_KEEPDASHDASH=
7 OPTIONS_SPEC="\
8 git am [options] [(<mbox>|<Maildir>)...]
9 git am [options] (--resolved | --skip | --abort)
11 i,interactive run interactively
12 b,binary* (historical option -- no-op)
13 3,3way allow fall back on 3way merging if needed
14 q,quiet be quiet
15 s,signoff add a Signed-off-by line to the commit message
16 u,utf8 recode into utf8 (default)
17 k,keep pass -k flag to git-mailinfo
18 keep-non-patch pass -b flag to git-mailinfo
19 keep-cr pass --keep-cr flag to git-mailsplit for mbox format
20 no-keep-cr do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
21 c,scissors strip everything before a scissors line
22 whitespace= pass it through git-apply
23 ignore-space-change pass it through git-apply
24 ignore-whitespace pass it through git-apply
25 directory= pass it through git-apply
26 exclude= pass it through git-apply
27 include= pass it through git-apply
28 C= pass it through git-apply
29 p= pass it through git-apply
30 patch-format= format the patch(es) are in
31 reject pass it through git-apply
32 resolvemsg= override error message when patch failure occurs
33 continue continue applying patches after resolving a conflict
34 r,resolved synonyms for --continue
35 skip skip the current patch
36 abort restore the original branch and abort the patching operation.
37 committer-date-is-author-date lie about committer date
38 ignore-date use current timestamp for author date
39 rerere-autoupdate update the index with reused conflict resolution if possible
40 rebasing* (internal use for git-rebase)"
42 . git-sh-setup
43 . git-sh-i18n
44 prefix=$(git rev-parse --show-prefix)
45 set_reflog_action am
46 require_work_tree
47 cd_to_toplevel
49 git var GIT_COMMITTER_IDENT >/dev/null ||
50 die "$(gettext "You need to set your committer info first")"
52 if git rev-parse --verify -q HEAD >/dev/null
53 then
54 HAS_HEAD=yes
55 else
56 HAS_HEAD=
59 cmdline="git am"
60 if test '' != "$interactive"
61 then
62 cmdline="$cmdline -i"
64 if test '' != "$threeway"
65 then
66 cmdline="$cmdline -3"
69 sq () {
70 git rev-parse --sq-quote "$@"
73 stop_here () {
74 echo "$1" >"$dotest/next"
75 git rev-parse --verify -q HEAD >"$dotest/abort-safety"
76 exit 1
79 safe_to_abort () {
80 if test -f "$dotest/dirtyindex"
81 then
82 return 1
85 if ! test -s "$dotest/abort-safety"
86 then
87 return 0
90 abort_safety=$(cat "$dotest/abort-safety")
91 if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
92 then
93 return 0
95 gettextln "You seem to have moved HEAD since the last 'am' failure.
96 Not rewinding to ORIG_HEAD" >&2
97 return 1
100 stop_here_user_resolve () {
101 if [ -n "$resolvemsg" ]; then
102 printf '%s\n' "$resolvemsg"
103 stop_here $1
105 eval_gettextln "When you have resolved this problem, run \"\$cmdline --resolved\".
106 If you prefer to skip this patch, run \"\$cmdline --skip\" instead.
107 To restore the original branch and stop patching, run \"\$cmdline --abort\"."
109 stop_here $1
112 go_next () {
113 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
114 "$dotest/patch" "$dotest/info"
115 echo "$next" >"$dotest/next"
116 this=$next
119 cannot_fallback () {
120 echo "$1"
121 gettextln "Cannot fall back to three-way merge."
122 exit 1
125 fall_back_3way () {
126 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
128 rm -fr "$dotest"/patch-merge-*
129 mkdir "$dotest/patch-merge-tmp-dir"
131 # First see if the patch records the index info that we can use.
132 cmd="git apply $git_apply_opt --build-fake-ancestor" &&
133 cmd="$cmd "'"$dotest/patch-merge-tmp-index" "$dotest/patch"' &&
134 eval "$cmd" &&
135 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
136 git write-tree >"$dotest/patch-merge-base+" ||
137 cannot_fallback "$(gettext "Repository lacks necessary blobs to fall back on 3-way merge.")"
139 say "$(gettext "Using index info to reconstruct a base tree...")"
141 cmd='GIT_INDEX_FILE="$dotest/patch-merge-tmp-index"'
143 if test -z "$GIT_QUIET"
144 then
145 eval "$cmd git diff-index --cached --diff-filter=AM --name-status HEAD"
148 cmd="$cmd git apply --cached $git_apply_opt"' <"$dotest/patch"'
149 if eval "$cmd"
150 then
151 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
152 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
153 else
154 cannot_fallback "$(gettext "Did you hand edit your patch?
155 It does not apply to blobs recorded in its index.")"
158 test -f "$dotest/patch-merge-index" &&
159 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
160 orig_tree=$(cat "$dotest/patch-merge-base") &&
161 rm -fr "$dotest"/patch-merge-* || exit 1
163 say "$(gettext "Falling back to patching base and 3-way merge...")"
165 # This is not so wrong. Depending on which base we picked,
166 # orig_tree may be wildly different from ours, but his_tree
167 # has the same set of wildly different changes in parts the
168 # patch did not touch, so recursive ends up canceling them,
169 # saying that we reverted all those changes.
171 eval GITHEAD_$his_tree='"$FIRSTLINE"'
172 export GITHEAD_$his_tree
173 if test -n "$GIT_QUIET"
174 then
175 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
177 git-merge-recursive $orig_tree -- HEAD $his_tree || {
178 git rerere $allow_rerere_autoupdate
179 die "$(gettext "Failed to merge in the changes.")"
181 unset GITHEAD_$his_tree
184 clean_abort () {
185 test $# = 0 || cat >&2 <<EOF
188 rm -fr "$dotest"
189 exit 1
192 patch_format=
194 check_patch_format () {
195 # early return if patch_format was set from the command line
196 if test -n "$patch_format"
197 then
198 return 0
201 # we default to mbox format if input is from stdin and for
202 # directories
203 if test $# = 0 || test "x$1" = "x-" || test -d "$1"
204 then
205 patch_format=mbox
206 return 0
209 # otherwise, check the first few non-blank lines of the first
210 # patch to try to detect its format
212 # Start from first line containing non-whitespace
214 while test -z "$l1"
216 read l1 || break
217 done
218 read l2
219 read l3
220 case "$l1" in
221 "From "* | "From: "*)
222 patch_format=mbox
224 '# This series applies on GIT commit'*)
225 patch_format=stgit-series
227 "# HG changeset patch")
228 patch_format=hg
231 # if the second line is empty and the third is
232 # a From, Author or Date entry, this is very
233 # likely an StGIT patch
234 case "$l2,$l3" in
235 ,"From: "* | ,"Author: "* | ,"Date: "*)
236 patch_format=stgit
240 esac
242 esac
243 if test -z "$patch_format" &&
244 test -n "$l1" &&
245 test -n "$l2" &&
246 test -n "$l3"
247 then
248 # This begins with three non-empty lines. Is this a
249 # piece of e-mail a-la RFC2822? Grab all the headers,
250 # discarding the indented remainder of folded lines,
251 # and see if it looks like that they all begin with the
252 # header field names...
253 tr -d '\015' <"$1" |
254 sed -n -e '/^$/q' -e '/^[ ]/d' -e p |
255 sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
256 patch_format=mbox
258 } < "$1" || clean_abort
261 split_patches () {
262 case "$patch_format" in
263 mbox)
264 if test t = "$keepcr"
265 then
266 keep_cr=--keep-cr
267 else
268 keep_cr=
270 git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
271 clean_abort
273 stgit-series)
274 if test $# -ne 1
275 then
276 clean_abort "$(gettext "Only one StGIT patch series can be applied at once")"
278 series_dir=`dirname "$1"`
279 series_file="$1"
280 shift
282 set x
283 while read filename
285 set "$@" "$series_dir/$filename"
286 done
287 # remove the safety x
288 shift
289 # remove the arg coming from the first-line comment
290 shift
291 } < "$series_file" || clean_abort
292 # set the patch format appropriately
293 patch_format=stgit
294 # now handle the actual StGIT patches
295 split_patches "$@"
297 stgit)
298 this=0
299 for stgit in "$@"
301 this=`expr "$this" + 1`
302 msgnum=`printf "%0${prec}d" $this`
303 # Perl version of StGIT parse_patch. The first nonemptyline
304 # not starting with Author, From or Date is the
305 # subject, and the body starts with the next nonempty
306 # line not starting with Author, From or Date
307 perl -ne 'BEGIN { $subject = 0 }
308 if ($subject > 1) { print ; }
309 elsif (/^\s+$/) { next ; }
310 elsif (/^Author:/) { s/Author/From/ ; print ;}
311 elsif (/^(From|Date)/) { print ; }
312 elsif ($subject) {
313 $subject = 2 ;
314 print "\n" ;
315 print ;
316 } else {
317 print "Subject: ", $_ ;
318 $subject = 1;
320 ' < "$stgit" > "$dotest/$msgnum" || clean_abort
321 done
322 echo "$this" > "$dotest/last"
323 this=
324 msgnum=
327 this=0
328 for hg in "$@"
330 this=$(( $this + 1 ))
331 msgnum=$(printf "%0${prec}d" $this)
332 # hg stores changeset metadata in #-commented lines preceding
333 # the commit message and diff(s). The only metadata we care about
334 # are the User and Date (Node ID and Parent are hashes which are
335 # only relevant to the hg repository and thus not useful to us)
336 # Since we cannot guarantee that the commit message is in
337 # git-friendly format, we put no Subject: line and just consume
338 # all of the message as the body
339 perl -M'POSIX qw(strftime)' -ne 'BEGIN { $subject = 0 }
340 if ($subject) { print ; }
341 elsif (/^\# User /) { s/\# User/From:/ ; print ; }
342 elsif (/^\# Date /) {
343 my ($hashsign, $str, $time, $tz) = split ;
344 $tz = sprintf "%+05d", (0-$tz)/36;
345 print "Date: " .
346 strftime("%a, %d %b %Y %H:%M:%S ",
347 localtime($time))
348 . "$tz\n";
349 } elsif (/^\# /) { next ; }
350 else {
351 print "\n", $_ ;
352 $subject = 1;
354 ' <"$hg" >"$dotest/$msgnum" || clean_abort
355 done
356 echo "$this" >"$dotest/last"
357 this=
358 msgnum=
361 if test -n "$patch_format"
362 then
363 clean_abort "$(eval_gettext "Patch format \$patch_format is not supported.")"
364 else
365 clean_abort "$(gettext "Patch format detection failed.")"
368 esac
371 prec=4
372 dotest="$GIT_DIR/rebase-apply"
373 sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
374 resolvemsg= resume= scissors= no_inbody_headers=
375 git_apply_opt=
376 committer_date_is_author_date=
377 ignore_date=
378 allow_rerere_autoupdate=
380 if test "$(git config --bool --get am.keepcr)" = true
381 then
382 keepcr=t
385 while test $# != 0
387 case "$1" in
388 -i|--interactive)
389 interactive=t ;;
390 -b|--binary)
391 gettextln >&2 "The -b/--binary option has been a no-op for long time, and
392 it will be removed. Please do not use it anymore."
394 -3|--3way)
395 threeway=t ;;
396 -s|--signoff)
397 sign=t ;;
398 -u|--utf8)
399 utf8=t ;; # this is now default
400 --no-utf8)
401 utf8= ;;
402 -k|--keep)
403 keep=t ;;
404 --keep-non-patch)
405 keep=b ;;
406 -c|--scissors)
407 scissors=t ;;
408 --no-scissors)
409 scissors=f ;;
410 -r|--resolved|--continue)
411 resolved=t ;;
412 --skip)
413 skip=t ;;
414 --abort)
415 abort=t ;;
416 --rebasing)
417 rebasing=t threeway=t ;;
418 --resolvemsg)
419 shift; resolvemsg=$1 ;;
420 --whitespace|--directory|--exclude|--include)
421 git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
422 -C|-p)
423 git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
424 --patch-format)
425 shift ; patch_format="$1" ;;
426 --reject|--ignore-whitespace|--ignore-space-change)
427 git_apply_opt="$git_apply_opt $1" ;;
428 --committer-date-is-author-date)
429 committer_date_is_author_date=t ;;
430 --ignore-date)
431 ignore_date=t ;;
432 --rerere-autoupdate|--no-rerere-autoupdate)
433 allow_rerere_autoupdate="$1" ;;
434 -q|--quiet)
435 GIT_QUIET=t ;;
436 --keep-cr)
437 keepcr=t ;;
438 --no-keep-cr)
439 keepcr=f ;;
441 shift; break ;;
443 usage ;;
444 esac
445 shift
446 done
448 # If the dotest directory exists, but we have finished applying all the
449 # patches in them, clear it out.
450 if test -d "$dotest" &&
451 last=$(cat "$dotest/last") &&
452 next=$(cat "$dotest/next") &&
453 test $# != 0 &&
454 test "$next" -gt "$last"
455 then
456 rm -fr "$dotest"
459 if test -d "$dotest"
460 then
461 case "$#,$skip$resolved$abort" in
462 0,*t*)
463 # Explicit resume command and we do not have file, so
464 # we are happy.
465 : ;;
467 # No file input but without resume parameters; catch
468 # user error to feed us a patch from standard input
469 # when there is already $dotest. This is somewhat
470 # unreliable -- stdin could be /dev/null for example
471 # and the caller did not intend to feed us a patch but
472 # wanted to continue unattended.
473 test -t 0
476 false
478 esac ||
479 die "$(eval_gettext "previous rebase directory \$dotest still exists but mbox given.")"
480 resume=yes
482 case "$skip,$abort" in
483 t,t)
484 die "$(gettext "Please make up your mind. --skip or --abort?")"
487 git rerere clear
488 git read-tree --reset -u HEAD HEAD
489 orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
490 git reset HEAD
491 git update-ref ORIG_HEAD $orig_head
494 if test -f "$dotest/rebasing"
495 then
496 exec git rebase --abort
498 git rerere clear
499 if safe_to_abort
500 then
501 git read-tree --reset -u HEAD ORIG_HEAD
502 git reset ORIG_HEAD
504 rm -fr "$dotest"
505 exit ;;
506 esac
507 rm -f "$dotest/dirtyindex"
508 else
509 # Make sure we are not given --skip, --resolved, nor --abort
510 test "$skip$resolved$abort" = "" ||
511 die "$(gettext "Resolve operation not in progress, we are not resuming.")"
513 # Start afresh.
514 mkdir -p "$dotest" || exit
516 if test -n "$prefix" && test $# != 0
517 then
518 first=t
519 for arg
521 test -n "$first" && {
522 set x
523 first=
525 if is_absolute_path "$arg"
526 then
527 set "$@" "$arg"
528 else
529 set "$@" "$prefix$arg"
531 done
532 shift
535 check_patch_format "$@"
537 split_patches "$@"
539 # -i can and must be given when resuming; everything
540 # else is kept
541 echo " $git_apply_opt" >"$dotest/apply-opt"
542 echo "$threeway" >"$dotest/threeway"
543 echo "$sign" >"$dotest/sign"
544 echo "$utf8" >"$dotest/utf8"
545 echo "$keep" >"$dotest/keep"
546 echo "$scissors" >"$dotest/scissors"
547 echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
548 echo "$GIT_QUIET" >"$dotest/quiet"
549 echo 1 >"$dotest/next"
550 if test -n "$rebasing"
551 then
552 : >"$dotest/rebasing"
553 else
554 : >"$dotest/applying"
555 if test -n "$HAS_HEAD"
556 then
557 git update-ref ORIG_HEAD HEAD
558 else
559 git update-ref -d ORIG_HEAD >/dev/null 2>&1
564 git update-index -q --refresh
566 case "$resolved" in
568 case "$HAS_HEAD" in
570 files=$(git ls-files) ;;
572 files=$(git diff-index --ignore-submodules --cached \
573 --name-only HEAD --) ;;
574 esac || exit
575 if test "$files"
576 then
577 test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
578 die "$(eval_gettext "Dirty index: cannot apply patches (dirty: \$files)")"
580 esac
582 # Now, decide what command line options we will give to the git
583 # commands we invoke, based on the result of parsing command line
584 # options and previous invocation state stored in $dotest/ files.
586 if test "$(cat "$dotest/utf8")" = t
587 then
588 utf8=-u
589 else
590 utf8=-n
592 keep=$(cat "$dotest/keep")
593 case "$keep" in
595 keep=-k ;;
597 keep=-b ;;
599 keep= ;;
600 esac
601 case "$(cat "$dotest/scissors")" in
603 scissors=--scissors ;;
605 scissors=--no-scissors ;;
606 esac
607 if test "$(cat "$dotest/no_inbody_headers")" = t
608 then
609 no_inbody_headers=--no-inbody-headers
610 else
611 no_inbody_headers=
613 if test "$(cat "$dotest/quiet")" = t
614 then
615 GIT_QUIET=t
617 if test "$(cat "$dotest/threeway")" = t
618 then
619 threeway=t
621 git_apply_opt=$(cat "$dotest/apply-opt")
622 if test "$(cat "$dotest/sign")" = t
623 then
624 SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
625 s/>.*/>/
626 s/^/Signed-off-by: /'
628 else
629 SIGNOFF=
632 last=`cat "$dotest/last"`
633 this=`cat "$dotest/next"`
634 if test "$skip" = t
635 then
636 this=`expr "$this" + 1`
637 resume=
640 while test "$this" -le "$last"
642 msgnum=`printf "%0${prec}d" $this`
643 next=`expr "$this" + 1`
644 test -f "$dotest/$msgnum" || {
645 resume=
646 go_next
647 continue
650 # If we are not resuming, parse and extract the patch information
651 # into separate files:
652 # - info records the authorship and title
653 # - msg is the rest of commit log message
654 # - patch is the patch body.
656 # When we are resuming, these files are either already prepared
657 # by the user, or the user can tell us to do so by --resolved flag.
658 case "$resume" in
660 if test -f "$dotest/rebasing"
661 then
662 commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
663 -e q "$dotest/$msgnum") &&
664 test "$(git cat-file -t "$commit")" = commit ||
665 stop_here $this
666 git cat-file commit "$commit" |
667 sed -e '1,/^$/d' >"$dotest/msg-clean"
668 echo "$commit" >"$dotest/original-commit"
669 get_author_ident_from_commit "$commit" >"$dotest/author-script"
670 git diff-tree --root --binary "$commit" >"$dotest/patch"
671 else
672 git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
673 <"$dotest/$msgnum" >"$dotest/info" ||
674 stop_here $this
676 # skip pine's internal folder data
677 sane_grep '^Author: Mail System Internal Data$' \
678 <"$dotest"/info >/dev/null &&
679 go_next && continue
681 test -s "$dotest/patch" || {
682 eval_gettextln "Patch is empty. Was it split wrong?
683 If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
684 To restore the original branch and stop patching run \"\$cmdline --abort\"."
685 stop_here $this
687 rm -f "$dotest/original-commit" "$dotest/author-script"
689 sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
690 echo
691 cat "$dotest/msg"
693 git stripspace > "$dotest/msg-clean"
696 esac
698 if test -f "$dotest/author-script"
699 then
700 eval $(cat "$dotest/author-script")
701 else
702 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
703 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
704 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
707 if test -z "$GIT_AUTHOR_EMAIL"
708 then
709 gettextln "Patch does not have a valid e-mail address."
710 stop_here $this
713 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
715 case "$resume" in
717 if test '' != "$SIGNOFF"
718 then
719 LAST_SIGNED_OFF_BY=`
720 sed -ne '/^Signed-off-by: /p' \
721 "$dotest/msg-clean" |
722 sed -ne '$p'
724 ADD_SIGNOFF=`
725 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
726 test '' = "$LAST_SIGNED_OFF_BY" && echo
727 echo "$SIGNOFF"
729 else
730 ADD_SIGNOFF=
733 if test -s "$dotest/msg-clean"
734 then
735 cat "$dotest/msg-clean"
737 if test '' != "$ADD_SIGNOFF"
738 then
739 echo "$ADD_SIGNOFF"
741 } >"$dotest/final-commit"
744 case "$resolved$interactive" in
746 # This is used only for interactive view option.
747 git diff-index --ignore-submodules -p --cached \
748 HEAD -- >"$dotest/patch"
750 esac
751 esac
753 resume=
754 if test "$interactive" = t
755 then
756 test -t 0 ||
757 die "$(gettext "cannot be interactive without stdin connected to a terminal.")"
758 action=again
759 while test "$action" = again
761 gettextln "Commit Body is:"
762 echo "--------------------------"
763 cat "$dotest/final-commit"
764 echo "--------------------------"
765 # TRANSLATORS: Make sure to include [y], [n], [e], [v] and [a]
766 # in your translation. The program will only accept English
767 # input at this point.
768 gettext "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
769 read reply
770 case "$reply" in
771 [yY]*) action=yes ;;
772 [aA]*) action=yes interactive= ;;
773 [nN]*) action=skip ;;
774 [eE]*) git_editor "$dotest/final-commit"
775 action=again ;;
776 [vV]*) action=again
777 git_pager "$dotest/patch" ;;
778 *) action=again ;;
779 esac
780 done
781 else
782 action=yes
785 if test -f "$dotest/final-commit"
786 then
787 FIRSTLINE=$(sed 1q "$dotest/final-commit")
788 else
789 FIRSTLINE=""
792 if test $action = skip
793 then
794 go_next
795 continue
798 if test -x "$GIT_DIR"/hooks/applypatch-msg
799 then
800 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
801 stop_here $this
804 say "$(eval_gettext "Applying: \$FIRSTLINE")"
806 case "$resolved" in
808 # When we are allowed to fall back to 3-way later, don't give
809 # false errors during the initial attempt.
810 squelch=
811 if test "$threeway" = t
812 then
813 squelch='>/dev/null 2>&1 '
815 eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
816 apply_status=$?
819 # Resolved means the user did all the hard work, and
820 # we do not have to do any patch application. Just
821 # trust what the user has in the index file and the
822 # working tree.
823 resolved=
824 git diff-index --ignore-submodules --quiet --cached HEAD -- && {
825 gettextln "No changes - did you forget to use 'git add'?
826 If there is nothing left to stage, chances are that something else
827 already introduced the same changes; you might want to skip this patch."
828 stop_here_user_resolve $this
830 unmerged=$(git ls-files -u)
831 if test -n "$unmerged"
832 then
833 gettextln "You still have unmerged paths in your index
834 did you forget to use 'git add'?"
835 stop_here_user_resolve $this
837 apply_status=0
838 git rerere
840 esac
842 if test $apply_status != 0 && test "$threeway" = t
843 then
844 if (fall_back_3way)
845 then
846 # Applying the patch to an earlier tree and merging the
847 # result may have produced the same tree as ours.
848 git diff-index --ignore-submodules --quiet --cached \
849 HEAD -- && {
850 say "$(gettext "No changes -- Patch already applied.")"
851 go_next
852 continue
854 # clear apply_status -- we have successfully merged.
855 apply_status=0
858 if test $apply_status != 0
859 then
860 eval_gettextln 'Patch failed at $msgnum $FIRSTLINE'
861 if test "$(git config --bool advice.amworkdir)" != false
862 then
863 eval_gettextln 'The copy of the patch that failed is found in:
864 $dotest/patch'
866 stop_here_user_resolve $this
869 if test -x "$GIT_DIR"/hooks/pre-applypatch
870 then
871 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
874 tree=$(git write-tree) &&
875 commit=$(
876 if test -n "$ignore_date"
877 then
878 GIT_AUTHOR_DATE=
880 parent=$(git rev-parse --verify -q HEAD) ||
881 say >&2 "$(gettext "applying to an empty history")"
883 if test -n "$committer_date_is_author_date"
884 then
885 GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
886 export GIT_COMMITTER_DATE
887 fi &&
888 git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
889 ) &&
890 git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
891 stop_here $this
893 if test -f "$dotest/original-commit"; then
894 echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
897 if test -x "$GIT_DIR"/hooks/post-applypatch
898 then
899 "$GIT_DIR"/hooks/post-applypatch
902 go_next
903 done
905 if test -s "$dotest"/rewritten; then
906 git notes copy --for-rewrite=rebase < "$dotest"/rewritten
907 if test -x "$GIT_DIR"/hooks/post-rewrite; then
908 "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
912 rm -fr "$dotest"
913 git gc --auto